'Placed in the Public Domain 5/24/97  John E. Carter
'johnecarter@mindspring.com
'
'requires PowerBasic 3.0 or higher to compile
'
'wildfind.bas - ver 1.3d - 09/29/95 (jec)
' 1.3d - 09/29/95 - deleted excess spaces in command line
' 1.3c - 12/29/94 - added file size to display
' 1.3b - 12/03/94 - removed Windows warning about network drives
'                 - added 'local' and 'remote' to drive info
' 1.3a - 05/23/94 - added programmer name to header
' 1.3  - 05/06/94 - added attributes to file name display
' 1.2a - 04/15/94 - corrected wording of network drive warning message
' 1.2  - 04/15/94 - added check for running in DOS box under Windows,
'                   warning about network drives, and option to exit
' 1.1  - 04/13/94 - added print to CONS: to allow for redirect
' 1.0  - 04/13/94 - original version, based on dir search in unbacked.bas
$include "regnames.inc"
$string 1
$lib com -, lpt -, graph -
$float emulate
$option cntlbreak on
$stack 32766
defint a-z
dim atr$(5)
atr$(0) = "r"  'read only
atr$(1) = "h"  'hidden
atr$(2) = "s"  'system
atr$(3) = "v"  'volume label
atr$(4) = "d"  'directory
atr$(5) = "a"  'archive

'tree search algorithm based on tree.bas, public domain code written by
'Eric Schonning (Fido 1:206/2505)

'this routine will create a complete tree listing for drive drv$
'using pb 2.1 dir$ command and dta information

dim dynamic dir.arr$(8000)  'array to hold directory info from dir$
dim thisdir$(8000)
dim quot$(10)
dim valdrv%(3:26)
totfiles! = 0
totdirs = 0
ustart! = timer
ver$ = "1.3d"
myname$ = "wildfind"
author$ = "John E. Carter"
countall% = 0
shownames% = 0
showexe% = 0
megs = 0
firstcd$ = ""
numcds% = 0
curline = 0
for k% = 3 to 26
  valdrv%(k%) = 0
next k%
cmd$ = ltrim$(rtrim$(ucase$(command$)))
'if cmd$<>"" then call parsecmd(cmd$, megs)
if cmd$ = "" then call info
spcloc = instr(cmd$," ")
colonloc = instr(cmd$,":")
if spcloc > 0 then
  srch$ = left$(cmd$, spcloc -1)
  drv$ = remove$(right$(cmd$, len(cmd$) - spcloc)," ")
  cmd$ = srch$
else
  colonloc = instr(cmd$,":")
  if colonloc > 0 then
    drv$ = ltrim$(rtrim$(cmd$))
  end if
end if
if len(drv$) > 0 then
  drv$ = left$(drv$,1)
end if
if (spcloc > 0 or colonloc > 0) and len(drv$) <> 1 then call info
if spcloc = 0 and colonloc > 0 then call info
win$ = environ$("windir")
'if win$ <> "" then
'  print
'  print "Running under Windows - any networked drives may be seen as local drives"
'  print "Press Esc to exit now, any other key to continue: ";
'  while not instat:wend
'  i$ = inkey$
'  if i$ = chr$(27) then end
'end if
open "cons:" for output as 1
color 7,0
cls
locate 1,1
print  myname$;
locate 1,33
print  author$;
locate 1, 75
print  ver$
locate 2,26
print "johnecarter@mindspring.com"
color 7,0
if drv$ = "" then
  'determine how many drives are on PC, then check each drive
  for drvnum% = 3 to 26            'start with drive C:, go to Z:
    reg %AX, &H3600
    reg %DX, drvnum%
    call interrupt &H21
    if reg(%AX) <> &HFFFF then  'found valid drive
      valdrv%(drvnum%) = 1
'    else
      clusdrv& = reg(%DX)
      if clusdrv& < 0 then incr clusdrv&, 65536  'allow for big drives
      drvsize& = reg(%AX) * reg(%CX) * clusdrv&
      freebytes& = FNfreespace&(drvnum%)
      print  using "#,###,###,###&&&";drvsize&;" total bytes on drive ";chr$(65 + drvnum% -1);":";
      print  using "&#,###,###,###&";"    ";freebytes&;" bytes available"
    end if
  next drvnum%
  numdrvs% = drvnum% -3
else
  drvnum% = asc(drv$) - 64
  reg %AX, &H3600
  reg %DX, drvnum%
  call interrupt &H21
  clusdrv& = reg(%DX)
  if clusdrv& < 0 then incr clusdrv&, 65536  'allow for big drives
  drvsize& = reg(%AX) * reg(%CX) * clusdrv&
  if drvsize& = 0 then
    print
    print "Error accessing drive ";drv$;":"
    end
  end if
  freebytes& = FNfreespace&(drvnum%)
  print  using "#,###,###,###&&&";drvsize&;" total bytes on drive ";chr$(65 + drvnum% -1);":";
  print  using "&#,###,###,###&";"    ";freebytes&;" bytes available"
  numdrvs% = 24
end if
print
if colonloc = 0 then
  print "Searching for ";cmd$
else
  print "Searching ";drv$;": for ";cmd$
  for k% = 3 to 26
    valdrv%(k%) = 0
  next k
  valdrv%(drvnum%) = 1
end if
call iscdrom(firstcd$, numcds%)
curline = csrlin
for cur% = 3 to numdrvs% + 2
  if valdrv%(cur%) = 0 then  'skip invalid drives
    iterate for
  end if
  if colonloc = 0 then
    drv$ = chr$(64 + cur%) + ":"
  else
    drv$ = drv$ + ":"
  end if
  isremote% = 0
  if colonloc > 0 then
    cur% = asc(drv$) - 64
  end if
  call checkremote(cur%, isremote%)
  if isremote% = 1 then
    print #1, ""
    if colonloc = 0 then
      if firstcd$ <> drv$ then
        print #1, "Skipping network drive ";drv$
        incr curline
        iterate for   'goto 99   'bug in iterate in PB 3.00a, fixed in 3.00b
      else
        beep
        color 14,0
        if curline > csrlin then
          if curline > 23 then
            locate 24,1
          else
            locate curline +1
          end if
        end if
        print
        print "Searching CD-ROM drive ";drv$;" will take several minutes."
'        print "If you do not have proper permissions on network drive ";drv$;","
'        print "        the system may lock up and you will have to reboot to recover."
        print "        Attempt search anyway? (Y/N) ";
        while not instat:wend
        i$ = ucase$(inkey$)
        print i$
        color 7,0
        if i$ <> "Y" then iterate for
      end if
    end if
  end if
  nonarc& = 0
  if numdrvs% > 1 and colonloc = 0 then
    print #1, ""
    incr curline
    print #1, "Checking ";
    if isremote% = 0 then
      print #1, "local";
    else
      if firstcd$ = drv$ then
        print #1, "CD-ROM";
      else
        print #1, "network";
      end if
    end if
    print #1, " drive ";drv$
    incr curline
  end if
  td%=1  'total directories on drive, start at 1 for root dir
  call get.disk.tree(drv$,td%,cmd$)
  print #1, ""
  incr curline
'  print using "#,###,###,###&&";nonarc&;" bytes not backed up on drive ";drv$
'  incr totnonarc&, nonarc&
'99 rem
next cur%
'if numdrvs% > 1 then
'  print
'  print using "#,###,###,###&";totnonarc&;" total bytes not backed up on local drives";
'end if
'print
secs = timer - ustart!
mins = secs\60
secs = secs - (mins * 60)
sec$ = ltrim$(str$(secs))
if secs < 10 then
  sec$ = "0" + sec$
end if
sec$ = left$(sec$,2)
color 7,0
print #1,  using "&##&&";"Complete in ";mins;":";sec$
end

sub get.dta.addr(dtaseg%,dtaofs%) local
  'get disk transfer area address
  reg 1,&h2f00
  call interrupt &h21
  dtaseg%=reg(9)
  dtaofs%=reg(2)
end sub

sub get.disk.tree(chkdir$,td%,cmd$) local
  shared dir.arr$(),drv$, filelen&, nonarc&, thisdir$(), countall%
  shared showexe%, shownames%, atr$(), curline
  'fa%=file attributes   tl%=total lines in dir
  'testdir$=directory to test
  fa%=0:tl%=0:chkdir$=ucase$(chkdir$):testdir$=""
  for xx% = 1 to 9
    test$ = test$ + chr$(xx%)
  next xx%
  do
    incr tl%
    if tl%=1 then
      if chkdir$=drv$ then       '    special handling for root directory
	testdir$=drv$+"\*.*"
	tk% = 0
	k$ = dir$(drv$ + "\*.*",32)
	while len(k$) > 0
	  incr tk%
	  thisdir$(tk%) = drv$ + "\" + k$
	  k$ = dir$
	wend
	for xx% = 1 to tk%   ' -1
	  k$ = thisdir$(xx%)
	  if instr(k$, any test$) > 0 then beep:?:?k$
          if instr(k$, cmd$) > 0 then
            av% = attrib(k$)
            print #1,  k$;" ";
            for xk% = 0 to 5
              if bit(av%, xk%) = 1 then
                print #1, atr$(xk%);
              end if
            next xk%
            print #1, " ";
            call justforjim(k$, filelen&)
            print #1, using "##,###,###"; filelen&
            incr curline
          end if
	next xx%
      else
	testdir$=chkdir$+"\*.*"
      end if
      dir.arr$(td%+1)=dir$(testdir$,16)
    else
      dir.arr$(td%+1)=dir$
    end if
    if dir.arr$(td%+1)="" then exit loop
    call get.dta.addr(dtaseg%,dtaofs%)
    def seg=dtaseg%
    fa%=peek(dtaofs%+21)
    def seg
    'test attribute for directory
    if (fa% and &b10000) then
      incr td%
      dir.arr$(td%)=chkdir$+"\"+dir.arr$(td%)
      tk% = 0
      k$ = dir$(dir.arr$(td%) + "\*.*",32)
      while len(k$) > 0
	incr tk%
	thisdir$(tk%) = dir.arr$(td%) + "\" + k$
	k$ = dir$
      wend
      for xx% = 1 to tk%  ' -1
	k$ = thisdir$(xx%)
	  if instr(k$, any test$) > 0 then beep:?:?k$
        if instr(k$, cmd$) > 0 then
          av% = attrib(k$)
          print #1,  k$;"  ";
          for xk% = 0 to 5
            if bit(av%, xk%) = 1 then
              print #1, atr$(xk%);
            end if
          next xk%
          print #1, " ";
          call justforjim(k$, filelen&)
          print #1, using "##,###,###"; filelen&
'          print #1, ""
          incr curline
        end if
      next xx%

      'call it again to check for sub-directories off of current dir
      call get.disk.tree(dir.arr$(td%),td%,cmd$)
      'must set dir$ back to where we left off before recursive call
      for i%=1 to tl%
        if i%=1 then null$=dir$(testdir$,16) else null$=dir$
      next i%
      dir.arr$(td%+1)=" "  'so it won't exit out of loop prematurely
    end if
  loop while dir.arr$(td%+1) <> ""
end sub

'Fm: John Watts 73760,751
'To: Jim McKeown 76702,1102 (X)
sub JustForJim( FileName$, FileLen& )          ' This is just for Jim <g>
'     print filename$, attrib(filename$)
'     if attrib(filename$) <> 32 then
'       print #1, filename$;" ";attrib(filename$);" not 32"
'       filelen& = 0
'       exit sub
'     end if
     FileName$ = DIR$(FileName$,32)            ' You have to use DIR$ first
     if filename$ = "" then
'       print filename$
       filelen& = 0
       exit sub           ' because it moves the DTA
     end if
'     print filename$
     reg(1),&h2f00                             ' if the file is found then
     call interrupt &h21                       ' locate the DTA and .....
     dta& = reg(9)*16+reg(2)+21
     map a$$ * 22,1 as attr$$,2 as t$$,2 as d$$,4 as s$$,13 as f$$
     def seg = 0           '       i        a        i         i
     a$$ =  peek$(dta&,22) '       m        t        z         l
     def seg               '       e        e        e         ename
     FileLen& = cvl(s$$)   '<-------------  Get the SIZE of the file
     tm = cvi(t$$)
     ft$ = bin$(tm)
     while len(ft$) < 16
       ft$ = "0" + ft$
     wend

     dt = cvi(d$$)
     fd$ = bin$(dt)
     while len(fd$) < 16
       fd$ = "0" + fd$
     wend

     print #1, FNcvtdate$(fd$);" ";FNcvttime$(ft$);" ";
end sub

DEF FNcvtdate$(fd$)
'converts binary string in fd$ to mm-dd-yy
  day$ = right$(fd$,5)
  dy = FNbinconv(day$)
  mon$ = mid$(fd$,8,4)
  mo = FNbinconv(mon$)
  yr$ = left$(fd$,7)
  year = FNbinconv(yr$) + 1980
  mon$ = ltrim$(str$(mo,2))
  if mo < 10 then mon$ = "0" + mon$
  day$ = ltrim$(str$(dy,2))
  if dy < 10 then day$ = "0" + day$
  FNcvtdate$ = mon$ + "/" + day$ + "/" + ltrim$(str$(year,4))
END DEF

DEF FNcvttime$(ft$)
'converts binary string in ft$ to hh:mm:ss
  sec$ = right$(ft$,5)
  secs = FNbinconv(sec$) * 2
  tmin$ = mid$(ft$,6,6)
  mnt = FNbinconv(tmin$)
  hr$ = left$(ft$,5)
  hour = FNbinconv(hr$)
  hr$ = ltrim$(str$(hour,2))
  if hour < 10 then hr$ = "0" + hr$
  tmin$ = ltrim$(str$(mnt,2))
  if mnt < 10 then tmin$ = "0" + tmin$
  sec$ = ltrim$(str$(secs,2))
  if secs < 10 then sec$ = "0" + sec$
  FNcvttime$ = hr$ + ":" + tmin$         '+ ":" + sec$
END DEF

DEF FNbinconv(x$)
'converts binary string to numeric value
  LOCAL k,t, q
  k = 0
  q = 0
  for t = len(x$) to 1 step -1
    if mid$(x$,t,1) = "1" then k = k + 2^q '(t-1)
    incr q
  next t
  FNbinconv = k
END DEF

'DEF FNcvtbin$(tm)
'k$ = string$(16,"0")
'for k = 16 to 1 step -1
'  if tm mod 2^(k-1) then
'    mid$(k$,k,1) = "1"
'    tm = tm - 2^(k-1) 'mod 2^k
'  end if
'next k
'FNcvtbin$ = k$
'END DEF

SUB center(x$,xwid)
	'centers a line of text in specified field width
	lx=(xwid-len(x$))/2
	x$ = space$(lx) + x$ + space$(lx)
	while len(x$) < xwid
	  x$ = x$ + " "
	wend
	if len(x$) > xwid then
	    x$ = left$(x$, xwid)
	end if
END SUB 'center

SUB parsecmd(x$, megs)
  shared countall%, shownames%, showexe%
  if instr(x$, any "?H") then
    call info
  end if
  num$ = ""
  numloc = instr(x$, any "0123456789")
  if numloc > 0 then
    for kk = numloc to len(x$)
      t$ = mid$(x$, kk, 1)
      if instr(t$, any "0123456789") then
	num$ = num$ + t$
      end if
    next kk
  end if
  megs = val(num$)
  if instr(x$,"A") > 0 then incr countall%
  if instr(x$,"S") > 0 then incr shownames%
  if instr(x$,"E") > 0 then incr showexe%
END SUB 'parsecmd



DEF FNfreespace&(drvno)
'call int &H21, function &H36 to get free space on drive 'drvno'
'0 = default drive, 1 = A, 2 = b, etc.
'on return, AX = sectors/cluster, BX = free clusters, CX = bytes/sector
'if AX = &HFFFF then error

  reg(%AX), &H3600                       'function number
  reg(%BX), 0
  reg(%CX), 0
  reg(%DX), drvno                        'drive number
  call interrupt &H21
  if reg(%AX) = -1 then
    print
    print #1, "Error accessing drive ";chr$(65 + drvno)
    beep
    print
    end
  end if
  availclus& = reg(%BX)
  if availclus& < 0 then incr availclus&, 65536
  FNfreespace& = reg(%CX) * reg(%AX) * availclus&   'reg(%BX)
END DEF

SUB checkremote(cur%, isremote%)
  reg %ax, &H4409         'get local/remote status, identifies CD-ROM as remote
  reg %bx, cur%
  call interrupt &h21
  if (reg(%dx) and 4096) then isremote% = 1
END SUB  'isremote

SUB ISCDROM(firstcd$, numcds%)
reg %ax, &H1500
call interrupt &H2f        'call to MSCDEX to check for CD-ROM drives
al = reg(%ax) and 255      'if al = 255, MSCDEX is loaded
bl = reg(%bx) and 255      'bl is number of CD-ROM drives on machine
cl = reg(%cx) and 255      'cl is number of first CD-ROM drive (zero based)
if al = 255 and bl > 0 then
'  print "CD-ROM(s): "; bl;"drive";
'  if bl > 1 then print "s beginning at";
'  print " ";chr$(cl + 65);":"
  firstcd$ = chr$(cl + 65) + ":"
  numcds% = bl
else
'  print "MSCDEX not loaded.  No CD-ROM drives found."
end if
END SUB

SUB info
  cls
  locate 2,1
  print "usage: wildfind text x:"
  print ""
  print "text - characters of file name to search for.  These characters"
  print "       may be anywhere in the file name or extension.  For example:"
  print "       WIN will find every file and directory with WIN in the name,"
  print "       including LOTTOWIN.XLS, WINA20.386, WINWORD, and every file"
  print "       under a matching directory name"
  print ""
  print "x:   - optional drive name to limit the search to just the named"
  print "       drive.  The default is all local drives starting with drive C:"
  end
END SUB


